'COMPANY        :  ALAM JURUTERA PERUNDING SDN. BHD.

'PROGRAM        :  STRUCTURAL ANALYSIS OF PLANE (2D) TRUSSES
'                  BY THE USE OF THE STIFFNESS / EQUILIBRUIM
'                  / DISPLACEMENT METHOD.

'PROGRAMMER     :  TEE HORNG HEAN
'                  B.Eng. (Hons) in Civil Engineering With Construction Management
'                  M.Sc. (Eng) in Structural Engineering Computational Technology

'START DATE     :  Unknown

'COMPLETION DATE:  Unknown

'COPYRIGHT      :  (C)
'                  This program is a product of Alam Jurutera
'                  Perunding Sdn. Bhd.  Any person who fraudulently
'                  places a copyright on this program, be it compiled,
'                  uncompiled, in another programming language or
'                  any other act which is contrary to the provisions
'                  of Malaysian's Copyright Act shall be subjected to
'                  the detrimental penalties specified therein.

'CAUTION        :  The Assumptions, Concepts and Theories in This
'                  Program are Correct.  THE  ENTIRE RISK  OF  THE
'                  USE  OF THE  RESULTS AND  PERFORMANCE  OF  THIS
'                  SOFTWARE IS  ASSUME ONLY BY YOU!

'TESTING        :  None
'

'REFERENCES     : Hill, F. S. 1990, "Computer Graphics", Prentice-Hall, NJ.
                 



SCREEN 12

DIM RM(1 TO 3, 1 TO 3) AS DOUBLE
DIM CoordX(21), CoordY(21), CoordZ(21) AS DOUBLE
DIM JN(65, 2), CLR(65)

Zoom = 200
CONST pi = 3.14159265358979#'to convert to radians

'If user didn't press ESC
WHILE A$ <> CHR$(27)
   CLS
   PRINT "[x] [y] [z] [X] [Y] [Z] [-] [+]"
   'ANGLES IN RADIANS
   x = Anglex * pi / 180
   y = Angley * pi / 180
   z = Anglez * pi / 180
  
   'SINES AND COSs
   SinX = SIN(x)
   CosX = COS(x)
   SinY = SIN(y)
   CosY = COS(y)
   SinZ = SIN(z)
   CosZ = COS(z)

   'ROTATION MATRIX
   RM(1, 1) = (CosZ * CosY)
   RM(1, 2) = (CosZ * -SinY * -SinX + SinZ * CosX)
   RM(1, 3) = (CosZ * -SinY * CosX + SinZ * SinX)
   RM(2, 1) = (-SinZ * CosY)
   RM(2, 2) = (-SinZ * -SinY * -SinX + CosZ * CosX)
   RM(2, 3) = (-SinZ * -SinY * CosX + CosZ * SinX)
   RM(3, 1) = SinY
   RM(3, 2) = CosY * -SinX
   RM(3, 3) = CosY * CosX

   'BEGIN AND END COORDINATES - COORDX ( JN(1,1) ), COORDY( JN(1,1) ) etc
   CoordX(1) = 0
   CoordY(1) = .5
   CoordZ(1) = 0
  
   CoordX(2) = .2939
   CoordY(2) = .4045
   CoordZ(2) = 0

   CoordX(3) = .4755
   CoordY(3) = .1545
   CoordZ(3) = 0

   CoordX(4) = .4755
   CoordY(4) = -.1545
   CoordZ(4) = 0
 
   CoordX(5) = .2939
   CoordY(5) = -.4045
   CoordZ(5) = 0
                  
   CoordX(6) = 0
   CoordY(6) = -.5
   CoordZ(6) = 0

   CoordX(7) = -.2939
   CoordY(7) = -.4045
   CoordZ(7) = 0
 
   CoordX(8) = -.4755
   CoordY(8) = -.1545
   CoordZ(8) = 0

   CoordX(9) = -.4755
   CoordY(9) = .1545
   CoordZ(9) = 0

   CoordX(10) = -.2939
   CoordY(10) = .4045
   CoordZ(10) = 0

   CoordX(11) = .1382
   CoordY(11) = .4253
   CoordZ(11) = .2236
 
   CoordX(12) = .4472
   CoordY(12) = 0
   CoordZ(12) = .2236

   CoordX(13) = .1382
   CoordY(13) = -.4253
   CoordZ(13) = .2236

   CoordX(14) = -.3618
   CoordY(14) = -.2629
   CoordZ(14) = .2236

   CoordX(15) = -.3618
   CoordY(15) = .2629
   CoordZ(15) = .2236
      
   CoordX(16) = 0
   CoordY(16) = 0
   CoordZ(16) = .5

   
   'CONNECTIVITY
   JN(1, 1) = 1
   JN(1, 2) = 2
   JN(2, 1) = 2
   JN(2, 2) = 3
   JN(3, 1) = 3
   JN(3, 2) = 4
   JN(4, 1) = 4
   JN(4, 2) = 5
   JN(5, 1) = 5
   JN(5, 2) = 6
   JN(6, 1) = 6
   JN(6, 2) = 7
   JN(7, 1) = 7
   JN(7, 2) = 8
   JN(8, 1) = 8
   JN(8, 2) = 9
   JN(9, 1) = 9
   JN(9, 2) = 10
   JN(10, 1) = 10
   JN(10, 2) = 1

   JN(11, 1) = 1
   JN(11, 2) = 11
   JN(12, 1) = 2
   JN(12, 2) = 11
   JN(13, 1) = 3
   JN(13, 2) = 12
   JN(14, 1) = 4
   JN(14, 2) = 12
   JN(15, 1) = 5
   JN(15, 2) = 13
   JN(16, 1) = 6
   JN(16, 2) = 13
   JN(17, 1) = 7
   JN(17, 2) = 14
   JN(18, 1) = 8
   JN(18, 2) = 14
   JN(19, 1) = 9
   JN(19, 2) = 15
   JN(20, 1) = 10
   JN(20, 2) = 15

   'NUMBER OF MEMBERS
   NoOfJoints = 21
   NoOfMembers = 20

   'COLORS
   FOR I = 1 TO 10: CLR(I) = 15: NEXT
   FOR I = 10 TO 20: CLR(I) = 14: NEXT
   FOR I = 21 TO 30: CLR(I) = 13: NEXT
   FOR I = 31 TO NoOfMembers: CLR(I) = 14: NEXT

   'SEARCH FOR "MOST" NEGATIVE NUMBER
   SMALL = CoordZ(1)
   FOR I = 1 TO NoOfJoints
      IF CoordZ(I) < SMALL AND CoordZ(I) < 0 THEN
        SMALL = CoordZ(I)
      END IF
      'IF CoordZ2(I) < SMALL AND CoordZ2(I) < 0 THEN
      '  SMALL = CoordZ2(I)
      'END IF
   NEXT I

   'IF THERE IS NEGATIVE NUMBERS
   IF SMALL < 0 THEN
      FOR I = 1 TO NoOfJoints
         CoordZ(I) = CoordZ(I) + ABS(SMALL)
         'CoordZ2(I) = CoordZ2(I) + ABS(SMALL)
      NEXT I
   ELSE
      SMALL = 0
   END IF



   'TRANSFORMATION
   FOR I = 1 TO NoOfJoints
      CoordX(I) = CoordX(I) * 1
      CoordY(I) = CoordY(I) * -1
      CoordZ(I) = CoordZ(I) * -1

      'CoordX2(I) = CoordX2(I) * 1
      'CoordY2(I) = CoordY2(I) * -1
      'CoordZ2(I) = CoordZ2(I) * -1
   NEXT I




FOR I = 1 TO NoOfMembers 'for every single line do this
       
       xc1 = CoordX(JN(I, 1))
       yc1 = CoordY(JN(I, 1))
       zc1 = CoordZ(JN(I, 1))
       x1 = (xc1 * RM(1, 1)) + (yc1 * RM(1, 2)) + (zc1 * RM(1, 3))
       y1 = (xc1 * RM(2, 1)) + (yc1 * RM(2, 2)) + (zc1 * RM(2, 3))
       z1 = (xc1 * RM(3, 1)) + (yc1 * RM(3, 2)) + (zc1 * RM(3, 3))

       xc2 = CoordX(JN(I, 2))
       yc2 = CoordY(JN(I, 2))
       zc2 = CoordZ(JN(I, 2))
       x2 = (xc2 * RM(1, 1)) + (yc2 * RM(1, 2)) + (zc2 * RM(1, 3))
       y2 = (xc2 * RM(2, 1)) + (yc2 * RM(2, 2)) + (zc2 * RM(2, 3))
       z2 = (xc2 * RM(3, 1)) + (yc2 * RM(3, 2)) + (zc2 * RM(3, 3))

       'draw new line (we can ignore z because the view is orthographic, not perspective)
       LINE (x1 * Zoom + 256, y1 * Zoom + 192)-(x2 * Zoom + 256, y2 * Zoom + 192), CLR(I)
     
       'Draw Global Axis
       'X                                             
       LINE (256, 192)-(400, 192), 1
       'Y
       LINE (256, 192)-(256, 50), 1
       'Z
       LINE (256, 192)-(100, 250), 1


NEXT I

A$ = INPUT$(1)

   'x, y and z rotates following the thumb curl rule
   'X, Y and Z opposses the above
   '+ and - scales the diagram
   IF A$ = "x" THEN Anglex = Anglex + 1
   IF A$ = "Y" THEN Angley = Angley + 1
   IF A$ = "z" THEN Anglez = Anglez + 1
   IF A$ = "X" THEN Anglex = Anglex - 1
   IF A$ = "y" THEN Angley = Angley - 1
   IF A$ = "Z" THEN Anglez = Anglez - 1
   IF A$ = "+" THEN Zoom = Zoom + 1
   IF A$ = "-" THEN Zoom = Zoom - 1
WEND



